100 REMark DIY Toolkit POP demo - Copyright 1989 Simon N Goodwin
110 REMark Adapted to use BPEEK and BPOKE routines 3rd July 1989
120 :
130 REMark This shows how the return stack can be manipulated to
140 REMark discard the last 'RETurn' details WITHOUT returning to
150 REMark the original caller. This may be useful when writing
160 REMark error-handling code (where you don't want to return to
170 REMark each intermediate caller after an error).
180 :
190 REMark This code only works under the SuperBASIC interpreter.
200 REMark Study it carefully before RENUMbering or changing it!
210 :
220 CLS : PRINT "Calling PROC2 via PROC1..."\\
230 PROC1
240 PRINT "PROC1 has finished..."
250 :
260 DEFine PROCedure PROC1
270 param=100000 : REMark Set global
280 PRINT "In PROC1, PARAM value before call to PROC2 = ";param\\
290 PROC2 -99999
300 REMark The POP should stop the next line being executed
310 PRINT "PROC2 has finished..."
320 END DEFine PROC1
330 :
340 DEFine PROCedure PROC2(param)
350 rtp=BASIC_L(60) : REMark Find return stack data
360 REMark The next four lines are just for illustration
370 PRINT "In PROC2, last call line : ";BPEEK_W%(rtp-6)
380 PRINT "Last call statement : ";BPEEK%(rtp-7)
390 PRINT "This line number : ";BPEEK_W%(104)
400 PRINT "Current local value of PARAM = ";param\\
410 REMark The next two lines do the POP
420 BPOKE rtp-7,1 : REMark Continue AFTER first statement...
430 BPOKE_W rtp-6,BPEEK_W%(104)+10 : RETurn : REMark ...on next line
440 PRINT "Ignored." : PRINT "Return stack tidied, still in PROC2..."
450 PRINT "Restored value of PARAM after POP = ";param\\
460 END DEFine PROC2
