1000 REMark PAGE_PRINT 1.7 by Simon N Goodwin, June 1993
1010 REMark Generates ASCII, Epson, HP PCL 3+
1020 REMark QL SuperBASIC; uses PAN #0,0,115 (SD.CURSEN)
1025 REMark Updated 1/6/93 for CR LF as well as LF line ends
1027 REMark Updated 15/9/93 to replace form feeds with spaces
1030 :
1040 REMark Turbo favours: IMPLICIT% i,j,k
1050 :
1060 page_length%=70
1070 column_gap%=4
1080 tab_width%=8
1090 print_device$="Ser"
1100 :
1110 PREPARE
1120 USER_INTERFACE
1130 PRINT_PAGES
1140 STOP
1150 :
1160 DEFine FuNction CHOICES%
1170 min_height%=10 : max_height%=4000
1180 MODE 4 : WINDOW 452,52,36,18 : PAPER 2,0 : CLS
1190 WINDOW 452,52,30,15 : BORDER 1,4,2 : PAPER 0 : CLS
1200 CSIZE 0,0 : AT 1,11 : CSIZE 2,1 : INK 7
1210 PRINT "Qdos PAGE PRINTING Utility"
1220 REMark Make italic banner
1230 FOR i=1 TO 9 : WINDOW 350,2,80,25+i*2 : PAN 10-i
1240 WINDOW 448,50,32,16 : CSIZE 1,0 : AT 3,3
1250 PRINT "Version 1.7 for DIY Toolkit  1993 Simon N Goodwin"
1260 REMark Add shadow to main window
1270 WINDOW 452,132,36,78 : PAPER 2,0 : CLS
1280 WINDOW 452,132,30,75 : BORDER 1,4,2 : PAPER 0 : CLS
1290 INPUT \" Input file (e.g. FLP1_BOOT): ";file$
1300 IF file$="" : PRINT #0;"Cancelled." : STOP
1310 REMark Add FTEST or DEVICE_STATUS here if required
1320 REPeat get_width
1330   PRINT \" Column width (e.g. 40): ";
1340   cols_used%=POSINT(#1)
1350   IF cols_used%<1 OR cols_used%>127
1360     PRINT \"Please specify a width between 1 and 127."
1370   ELSE 
1380     EXIT get_width
1390   END IF 
1400 END REPeat get_width
1410 col_spacing%=cols_used% + column_gap%
1420 WINDOW #0;452,32,36,218 : PAPER #0,2,0 : CLS #0
1430 WINDOW #0;452,32,30,215 : BORDER #0,1,4,2 : PAPER #0,0
1440 CLS #0 : BORDER #0,4,128 : INK #0,7 : CSIZE #0,1,0
1450 :
1460 CLS : PAPER 2 : INK 7 : CSIZE 2,0
1470 AT 1,3:PRINT " Printer        Lines   Columns "
1480 AT 2,3:PRINT " standard       /page    /page  "
1490 i=1 : PAPER 4 : INK 0 : SHOW_VER$
1500 PAPER 0 : INK 7 : FOR i=2 TO pages% : SHOW_VER$
1510 PRINT #0;"For best PAGE PRINT results, pick the ";
1520 PRINT #0;"version to suit ";
1530 INK #0,4 : PRINT #0;"your "; : INK #0,7
1540 PRINT #0;"eyes and printer. Press ENTER to use the menu. ";
1550 SURE_PAUSE : i=1
1560 REPeat choose
1570   CLS #0
1580   PRINT #0;" Use the vertical arrows (  ) to choose a version."
1590   PRINT #0;" Press SPACE to confirm, or ESC to return to BASIC. "
1600   REPeat poll
1610     PAUSE : k=KEYROW(1)
1620     IF k=0 : NEXT poll
1630     IF (k && 128) AND i<pages%
1640       SHOW_VER$ : i=i+1 : PAPER 4 : INK 0
1650       SHOW_VER$ : PAPER 0 : INK 7
1660     END IF 
1670     IF (k && 4) AND i>1
1680       SHOW_VER$ : i=i-1 : PAPER 4 : INK 0
1690       SHOW_VER$ : PAPER 0 : INK 7
1700     END IF 
1710     IF k && 64
1720       CLS #0
1730       PRINT #0;"PAGE PRINT version " & i;
1740       PRINT #0;" selected - are you sure?";
1750       IF YEA_OR_NAY : EXIT choose : ELSE NEXT choose
1760     END IF 
1770     IF k && 8
1780       CLS #0 : PRINT #0;" Cancelled." : STOP
1790     END IF 
1800   END REPeat poll
1810 END REPeat choose
1820 CLS #0
1830 PRINT #0;"The default paper size is A4, with ";
1840 PRINT #0;page_length%;" lines per page."
1850 IF i>=epson%
1860   PRINT #0;"Do you want to change this";
1870   IF YEA_OR_NAY
1880     REPeat get_length
1890       CLS #0 : PRINT #0;'Enter page length, in standard ';
1900       PRINT #0;'3.1mm or 1/6" lines ?'
1910       page_length%=POSINT(#0)
1920       IF page_length%<min_height% OR page_length%>max_height%
1930         PRINT #0;"Sorry, this software expects ";
1940         PRINT #0;min_height%;" to ";max_height%;" lines/page."
1950         PRINT #0;"Press ENTER to try again or ESC to quit. ";
1960         SURE_PAUSE
1970       ELSE 
1980         EXIT get_length
1990       END IF 
2000     END REPeat get_length
2010   END IF 
2020   REMark Work out gap between pages
2030   blanks%=5 * ( 1 + (i=4 OR i=5) )
2040   temp%=(height%(i)+blanks%)/70 * page_length% - blanks%
2050   height%(i)=temp%
2060 ELSE 
2070   blanks%=0:REMark No explicit blank lines in HP mode
2080 END IF 
2090 RETurn i
2100 END DEFine CHOICES%
2110 :
2120 DEFine PROCedure SHOW_VER$
2130 AT i+3,3 : PRINT title$(i);
2140 PRINT TO 20;height%(i) TO 29;
2150 PRINT (width%(i) + column_gap%) DIV col_spacing% TO 35
2160 END DEFine SHOW_VER$
2170 :
2180 DEFine FuNction YEA_OR_NAY
2190 LOCal k$(2)
2200 PRINT #0;" (Y/N) ";
2210 REPeat loop
2220   k$=INKEY$(#0,-1)
2230   IF k$=="y" OR k$=="n" : EXIT loop
2240 END REPeat loop
2250 PRINT #0;k$ : RETurn k$<>"n"
2260 END DEFine YEA_OR_NAY
2270 :
2280 DEFine PROCedure SURE_PAUSE
2290 PAN #0,0,115 :REMark Turn cursor on
2300 PAUSE 5 : PAUSE 5 : PAUSE 5 : REMark Lose key bounce
2310 IF INKEY$(#0,-1)=esc$ : PRINT #0\\"Escape pressed." : STOP
2320 END DEFine SURE_PAUSE
2330 :
2340 DEFine FuNction POSINT(channel%)
2350 LOCal k$(6)
2360 INPUT #channel%;k$
2370 IF "e" INSTR k$ OR k$="" THEN k$="0"
2380 IF k$<0 OR k$>32767 THEN k$=""
2390 RETurn "0" & k$
2400 END DEFine POSINT
2410 :
2420 DEFine PROCedure PREPARE
2430 LOCal i
2440 tab$=CHR$(9) : formfeed$=CHR$(12) : esc$=CHR$(27) : space$=CHR$(32)
2450 hpx$=esc$ & "&" : hpt$=esc$ & "(" : form_feed$=CHR$(12)
2460 print%=3
2470 disk%=4
2480 epson_init$=esc$ & "@":REMark Reset Epson to power-up state
2490 REMark LF -> CR/LF, Wrap at right margin if line overflows
2500 hp_init$=hpx$ & "s0C" & hpx$ & "k2G" & hpx$
2510 REMark Use portrait A4 paper, PC850 character set
2520 hp_init$=hp_init$ & "l26a0o12d144p0l128F" & hpt$ & "(12U"
2530 LET spec_max%=32:REMark length limit for page setup strings
2540 LET title_max%=12:REMark Limiting length of printer name
2550 LET pages%=7:REMark Total number of formats
2560 LET epson%=3:REMark First Epson variant
2570 REMark Aim to be ready for anything!
2580 DIM width%(pages%),height%(pages%)
2590 DIM page_spec$(pages%,spec_max%),title$(pages%,title_max%)
2600 RESTORE 2740
2610 FOR i=1 TO pages%
2620   READ title$(i)
2630   READ temp$ : IF i<epson% : page_spec$(i)=hpt$ & temp$
2640   READ width%(i),height%(i)
2650 END FOR i
2660 REMark Control codes don't suit constant DATA
2670 page_spec$(3)=CHR$(15) & esc$ & "M"
2680 page_spec$(5)=CHR$(15) & esc$ & "3" & CHR$(18) & esc$ & "S0"
2690 page_spec$(4)=page_spec$(5) & esc$ & "M"
2700 page_spec$(6)=CHR$(15)
2710 END DEFine PREPARE
2720 :
2730 REMark Name, setup string, width, height in characters
2740 DATA  "HP 1","s0p12h6v0s0b6t2Q",96,130
2750 DATA  "HP 2","s0p24h6v0s0b6t2Q",192,130
2760 DATA  "New Epson 1","",160,65
2770 DATA  "New Epson 2","",160,130
2780 DATA  "Old Epson","",132,130
2790 DATA  "Condensed","",132,65
2800 DATA  "Plain ASCII","",80,65
2810 :
2820 DEFine PROCedure USER_INTERFACE
2830 LOCal t%
2840 form% = CHOICES%
2850 REMark INPUT "File name     : ";file$
2860 REMark INPUT "Column width  : ";cols_used%
2870 REMark INPUT "Format (1..7) : ";form%
2880 REMark blanks%=5 * ( 1 + (form%=4 OR form%=5) )
2890 REMark col_spacing%=cols_used% + column_gap%
2900 IF form%<epson%
2910   pr_init$=hp_init$
2920 ELSE 
2930   IF form%<6 THEN pr_init$=epson_init$
2940 END IF 
2950 page_size$=page_spec$(form%)
2960 t%=width%(form%) : REMark "JM" bodge
2970 DIM grid$(height%(form%),t%)
2980 BLANK_PAGE
2990 END DEFine USER_INTERFACE
3000 :
3010 DEFine PROCedure PRINT_PAGES
3020 PRINT_INIT
3030 page_count%=0 : row%=1 : col%=1
3040 PRINT_FILE
3050 IF row%+col%<>2 : PRINT_PAGE :REMark Do anything left
3060 CLOSE #print%
3070 CLS #0 : PRINT #0;page_count%;" page";
3080 IF page_count%<>1 : PRINT #0;"s";
3090 PRINT #0;" printed."
3100 END DEFine PRINT_PAGES
3110 :
3120 DEFine PROCedure PRINT_INIT
3130 OPEN #print%,print_device$
3140 PRINT #print%;pr_init$;
3150 PRINT #print%;page_size$;
3160 END DEFine PRINT_INIT
3170 :
3180 DEFine PROCedure PRINT_FILE
3190 OPEN_IN #disk%,file$
3200 REPeat add_line
3210   IF EOF(#disk%) : EXIT add_line
3220   INPUT #disk%;line$;
3225   IF line$<>""
3226     formfeed%=formfeed$ INSTR line$
3227     IF formfeed%<>0 : line$(formfeed%)=space$
3228     IF line$(LEN(line$))=CHR$(13) : line$=line$(1 TO LEN(line$)-1)
3230     EXPAND_TABS line$
3240     BUFFER line$
3245   END IF 
3250 END REPeat add_line
3260 CLOSE #disk%
3270 END DEFine PRINT_FILE
3280 :
3290 REFERENCE line$ :REMark Turbo only
3300 DEFine PROCedure EXPAND_TABS(t$)
3310 LOCal t%,f$(tab_width%)
3320 REPeat look
3330   t% = tab$ INSTR t$
3340   IF t% = 0 OR t%=LEN(t$) : EXIT look
3350   f$=FILL$(space$,tab_width% - (t%-1) MOD tab_width%)
3360   t$=t$(1 TO t%-1) & f$ & t$(t%+1 TO)
3370 END REPeat look
3380 END DEFine EXPAND_TABS
3390 :
3400 DEFine PROCedure BUFFER(line$)
3410 grid$(row%,col% TO col%+cols_used%-1)=line$
3420 row% = row% + 1
3430 IF row% > height%(form%)
3440   row%=1 :REMark Back to the top
3450   col% = col% + col_spacing%
3460   IF col%-1 > width%(form%)-cols_used%
3470     PRINT_PAGE
3480     col%=1
3490   END IF 
3500 END IF 
3510 END DEFine BUFFER
3520 :
3530 DEFine PROCedure PRINT_PAGE
3540 LOCal i
3550 FOR i=1 TO height%(form%)
3560   PRINT #print%;grid$(i,1 TO width%(form%))
3570 END FOR i
3580 IF form%<epson%
3590   PRINT #print%;form_feed$;
3600 ELSE 
3610   REMark Skip perforation
3620   FOR i=1 TO blanks% : PRINT #print%
3630 END IF 
3640 page_count%=page_count%+1
3650 BLANK_PAGE
3660 END DEFine PRINT_PAGE
3670 :
3680 DEFine PROCedure BLANK_PAGE
3690 LOCal j
3700 FOR j=1 TO height%(form%)
3710   grid$(j)=FILL$(space$,width%(form%))
3720 END FOR j
3730 END DEFine BLANK_PAGE
3740 :
3750 DEFine PROCedure S
3760 SAVE "FLP1_QLW_PAGE_BAS"
3770 END DEFine S
