100 CLS : CSIZE 2,1 : PRINT "SEARCH demonstration." : CSIZE 1,0
110 PRINT "SEARCH uses QLINK, QCOUNT%,"!"PARSEPA, PARNAME$ and UNSET."
120 PRINT "It prints the number of all"!"program lines containing TEXT$."
130 LIST #0;140 TO 160
140 SEARCH "first",100 TO 500,20
150 SEARCH line$,100 TO 400
160 SEARCH "interval"!
170 :
180 REMark N.B: BASIC stops (at the LIST) if it runs past the end of the
200 REMark program, in "MG" SuperBASIC as well as Thor BASIC 6.4.1.
210 REMark This means the line range is not printed after a search that
220 REMark reaches the end of the program.
230 :
240 DEFine PROCedure SEARCH(text$,first%,final%,interval%)
250 REMark SEARCH name | string expr [ ! | firstline TO lastline [ , step ] ]
270 REMark Defaults are assumed if ! is typed in place of FIRST% etc.
280 REMark The step between lines INTERVAL% defaults to 10 if not supplied
290 LOCal line$(2000),n
300 :
310 CLS 2
320 IF UNSET(text$) : text$=PARNAME$(1) : REMark Use the name!
330 IF UNSET(first%)
340   IF PARSEPA(text$)=4
350     first%=100 : final%=32760 : interval%=10 : REMark Defaults
360   ELSE 
370     PRINT "Pattern: ";text$
380     REPeat bounds
390       INPUT "First line to scan: ";first%
400       INPUT "Final line to scan: ";final%
410       IF final%>=first% : EXIT bounds
420     END REPeat bounds
430     REPeat interval
440       INPUT "Interval between line numbers? ";interval%
450       IF interval%>0 : EXIT interval
460     END REPeat interval
470   END IF 
480 END IF 
490 IF UNSET(interval%) THEN interval%=10
500 :
510 OPEN #4,pipe_2000
520 QLINK #4 TO #3
530 PRINT \"Searching for '";text$;"' ..."
540 FOR n=first% TO final% STEP interval%
550   LIST #4,n
560   IF QCOUNT%(#4)>0
570     INPUT #3,line$
580     IF text$ INSTR line$ THEN PRINT !n!
590   END IF 
600 END FOR n
610 PRINT \first%;" TO ";final%;" STEP ";interval%;" searched."
620 CLOSE #3
630 CLOSE #4
640 END DEFine SEARCH
