100 REMark Common & User Heap scanners PRS/SNG v3.5 19/3/91
110 :
120 v$=VER$ : IF v$="AH" OR v$="JM"
130   PRINT #0;"Sorry, AH and JM ROM bugs upset this"\"scanner. SETLOAD_DOC explains why." : STOP
140 END IF 
150 x=RESPR(760) : LBYTES "flp1_ALTER_CODE",x : CALL x
160 REMark To work properly these need to be the first two
170 REMark SET commands after the LBYTES...
180 SET SENTINEL TO x+12
190 SET HEAP_START TO PEEK_L(SENTINEL)+SENTINEL-16
200 REMark The -16 ensures that SENTINEL is itself in the SHOW_ALL list
210 REMark so that SET ITSELF TO PEEK_L(SENTINEL)+SENTINEL makes
220 REMark ITSELF hold the address of its own code in the user heap!
230 SET# SV_HEAP TO 4
240 SET# SV_FREE TO 12
250 REMark SYSBASE and these Resident Pointers are used in PROC CHEAP
260 CHEAP : PAUSE 200 : SHOW_HEAP
270 STOP
280 :
290 DEFine FuNction FREE_HEAP
300 REMark Returns size of the FIRST group of unused bytes in the SET HEAP
310 RETurn PEEK_L(PEEK_L(SENTINEL)+SENTINEL-4)
320 END DEFine 
330 :
340 DEFine PROCedure SHOW_HEAP
350 LOCal p,f
360 REMark Shows used and unused entries from the first SHOW heap block,
370 REMark as long as you set up SENTINEL and HEAP_START as above. SNG
380 LET p=HEAP_START : LET f=SENTINEL
390 REMark Skip over any extension blocks at lower addresses...
400 REPeat seek : f=f+PEEK_L(f) : IF PEEK_L(f)=0 OR f>=p : EXIT seek
410 CSIZE 1,1 : PRINT "Heap address" TO 15;"Bytes" : CSIZE 1,0
420 REPeat loop
430   LET length=PEEK_L(p-4)
440   PRINT " @ ";p-4; TO 14;length!!
450   IF p=f : PRINT 'free' : f=f+PEEK_L(f) : ELSE PRINT 'used'
460   IF PEEK_L(p)=0 : EXIT loop
470   LET p=p + length
480 END REPeat loop
490 END DEFine 
500 :
510 DEFine FuNction JOB_NAME$(num,tag)
520     IF  num = 0 THEN 
530       RETurn "SuperBASIC"
540     ELSE 
550       sv_chbas = PEEK_L(SYSBASE+104)
560       jb_ptr = sv_chbas+(num*4)
570       REMark Is this job number in use ?
580       IF PEEK(jb_ptr) <> 255 THEN 
590         jb_start = PEEK_L(jb_ptr)
600         REMark Is the tag correct ?
610         IF tag = PEEK_W(jb_start+16) THEN 
620           REMark Is that an Ident Word (19195 = $4AFB) ?
630           IF PEEK_W(jb_start+110) = 19195 THEN 
640             RETurn MPEEK$(jb_start+114,PEEK_W(jb_start+112))
650           ELSE 
660             RETurn "No Name"
670           END IF 
680         END IF 
690       END IF 
700       RETurn "Lost"
710     END IF 
720 END DEFine JOB_NAME$
730 :
740 DEFine PROCedure CHEAP
750 REMark List Blocks in common heap and indicate owner or if free
760 REMark Revised to show HEADER & START addresses separately, 2/91
770 REMark N.B: LENGTH includes the 16 byte header.
780 REMark Now uses HEAP_START to identify the first SET HEAP block.
790 REMark Calls SYSBASE, SV_HEAP = 4(SV_A6) and SV_FREE = 12(SV_A6)
800 :
810 setblock = HEAP_START-20 : REMark Locate the SET buffer
820 :
830 start = SV_HEAP : REMark First linkage starts the System Variables
840 PRINT \"Common Heap"
850 PRINT "header" TO 9;"start" TO 18;"length" TO 27;"addr" TO 36;"addset" TO 45; "owner"
860 free_ptr = NEXT_FREE(SYSBASE+4)  : REMark SV.CHEAP -> first free block
870 REPeat scan
880   length = PEEK_L(start)
890   address = PEEK_L(start+4)
900   jobtag = PEEK_W(start+8)
910   jobnum = PEEK_W(start+10)
920   addset = PEEK_L(start+12)
930   PRINT start TO 9; start+16 TO 18; length TO 27; address TO 36; addset TO 45;
940   REMark is this block free
950   IF start = free_ptr THEN 
960     free_ptr = NEXT_FREE(free_ptr) : REMark Find next free block
970     PRINT "<< FREE >>"
980     addset = 0 : REMark Not used in free list
990   ELSE 
1000     IF start=setblock
1010       PRINT '"SET" HEAP'
1020     ELSE 
1030       PRINT JOB_NAME$(jobnum,jobtag)
1040     END IF 
1050   END IF 
1060   REMark if next start = SV.FREE this is the last block
1070   start = start + length : REMark Find start of next block
1080   IF start = SV_FREE THEN EXIT scan
1090 END REPeat scan
1100 END DEFine CHEAP
1110 :
1120 DEFine FuNction NEXT_FREE(start)
1130  REMark Find next free space in any QDOS heap
1140  REMark start = address of the start of a free block
1150  IF PEEK_L(start)= 0 THEN 
1160    REMark End of linked list
1170    RETurn 0
1180  ELSE 
1190    REMark return start of next free block
1200    RETurn start+PEEK_L(start+4)
1210  END IF 
1220 END DEFine NEXT_FREE
1230 :
1240 DEFine FuNction MPEEK$(addr,len%)
1250 LOCal p,t$
1260 t$='' : REMark Read LEN% consecutive bytes from addr via T$
1270 FOR p=addr TO addr+len%-1
1280   t$=t$ & CHR$(PEEK(p))
1290 END FOR p
1300 RETurn t$
1310 REMark Mega Toolbox/Turbo Toolkit/Quanta Library PEEK$ is faster
1320 END DEFine MPEEK$
1330 :
1340 REMark DEFine FuNction SYSBASE
1350 RETurn 163840 : REMark Include this DEF unless you
1360 REMark have loaded the DIY Toolkit SYSBASE function.
1370 REMark This BASIC version works on most QDOS/Argos
1380 REMark systems, but it is not portable.
1390 REMark Minerva users should: RETurn VER$(-2)
1400 REMark END DEFine SYSBASE
