100 REMark QBASE Device driver list analyser
110 REMark Copyright 1990 Simon N Goodwin & Phil Spink
120 :
130 MODE 4: DIR_DEVS
140 SER_DEVS
150 :
160 DEFine PROCedure SER_DEVS
170 start=PEEK_L(SYSBASE+68):REMark Start of simple device list
180 PRINT \"Simple device driver list:"
190 REPeat loop
200   IF start=0:EXIT loop
210   PRINT SDEV_NAME$(PEEK_L(start+8)),
220   ANALYST
230   start=PEEK_L(start)
240 END REPeat loop
250 PRINT "That's all."
260 END DEFine
270 :
280 DEFine PROCedure ANALYST
290   PRINT "Start: ";start,
300   PRINT "  I/O: ";PEEK_L(start+4),
310   PRINT "  OPEN: ";PEEK_L(start+8),
320   PRINT "  CLOSE: ";PEEK_L(start+12)
330 END DEFine
340 :
350 DEFine PROCedure DIR_DEVS
360 start=PEEK_L(SYSBASE+72):REMark Start of directory device list
370 PRINT \"Directory device driver list:"
380 REPeat loop
390   IF start=0:EXIT loop
400   PRINT MPEEK$(start+38,PEEK_W(start+36)),
410   ANALYST
420   start=PEEK_L(start)
430 END REPeat loop
440 PRINT "That's all."
450 END DEFine
460 :
470 DEFine FuNction SDEV_NAME$(dev_open)
480 LOCal name_in$,dev$,len_name,x,y,z,name_at
490   name_in$ = MPEEK$(dev_open,100):len_name=LEN(name_in$)
500   x = "`" INSTR name_in$
510   y = "`" INSTR name_in$(x+1 TO len_name)
520   z = "`" INSTR name_in$(x+y+1 TO len_name)
530   IF x>0 AND y = 2 AND z = 2 THEN
540      name_at = dev_open+x+4+1
550      dev$ = MPEEK$(name_at+2,PEEK_W(name_at))
560   ELSE
570      dev$ = ""
580   END IF
590   RETurn dev$
600 END DEFine
610 :
620 DEFine FuNction MPEEK$(addr,len%)
630 LOCal p,t$
640 t$='' : REMark Use Turbo TK PEEK$ for more speed
650 FOR p=addr TO addr+len%-1
660   t$=t$ & CHR$(PEEK(p))
670 END FOR p
680 RETurn t$
690 END DEFine MPEEK$
700 :
710 REMark N.B. Addresses      0 - 131071  is ROM and System space
720 REMark in particular       0 - 49151   is the 48K QDOS system ROM
730 REMark                 49152 - 65535   is the 16K cartridge port
740 REMark                131072 - 786432  is 640K RAM
750 REMark                786433 - 1048576 is 8 x 16K ROM slots
760 REMark (or maybe 256K of RAM, on 'Trump Card' QL systems)
770 REMark               1048577 +         are non-QL 680x0 addresses
780 REMark (accessible on THOR XVI, Amiga, ST QDOS emulators, etc)
