100 REMark NETPAL - a QL remote command server
110 REMark for people with more QLs than Monitors
120 REMark (and why not - they're cheaper!)
130 REMark Copyright 1990 Simon N Goodwin, v 1.1
140 :
150 REMark OPERATIONAL NOTES:
160 REMark The other machine must be made to FSERVE
170 REMark to allow NETPAL to work.
180 :
190 REMark IMPLEMENTATION NOTES:
220 REMark Add IMPLICIT% TXTLEN if compiling with TURBO.
250 REMark You need the SuperToolkit 2 ROM at both ends.
260 REMark Unfortunately BAD LINE errors are not trapped!
270 REMark PIX requires the MEM device at the other end.
280 :
290 REMark This version uses DIY Toolkit BPOKE, QUEUE%
300 REMark and CLS 115 to move the remote cursor.
310 REMark It implements lazy deletion.
330 :
340 CANCEL_ERROR
350 back$=CHR$(194) : enter$=CHR$(10)
360 prompt$ = "NETPAL>" : command$=""
370 :
380 STARTUP : HEADING
390 :
400 REMark MAIN LOOP
410 REMark Adjust the second TYPE_IN, below
420 REMark if you renumber the next line!
430 IF ERNUM
440   PAPER #3,2 : PRINT #3;"ERROR: ";command$;
450   PAPER #3,0 : INK #3,4 : REPORT #3 : INK #3,7
460   CANCEL_ERROR
470 END IF 
480 dpos%="date" INSTR prompt$
490 IF dpos% <> 0
500   PRINT #3;prompt$(1 TO dpos%-1);
510   PRINT #3;DATE$;
520   IF dpos%+3<LEN(prompt$)
530     PRINT #3;prompt$(dpos% +4 TO);
540   END IF 
550 ELSE 
560   PRINT #3;prompt$;
570 END IF 
580 GETLINE command$
590 REMark DIY Toolkit QUEUE% works like TYPE_IN
600 REMark Beware of BAD LINE errors!
610 t=QUEUE%(command$)
620 REMark Beware of CTRL-F5 lockups!
630 t=QUEUE%("RUN 430" & enter$)
640 STOP
650 :
660 DEFine PROCedure GETLINE(txt$)
670 LOCal key$,txtlen
680 txt$=""
690 REPeat poll
700   key$=INKEY$(#3,-1)
710   IF key$=CHR$(195) THEN txt$="" : SCROLL #3,0,121 : CLS #3,3 : PRINT #3,prompt$;
720   IF key$ = back$
725     txtlen=LEN(txt$)
730     IF txtlen > 0
740       REMark Move remote cursor back 2 places
750       SCRUB 2
760       REMark Wipe out deleted character & splodge
770       PRINT #3,"  ";
780       REMark Move cursor to end of remaining text
790       SCRUB 2
800     END IF 
810     SELect ON txtlen
820       =0 : SCRUB 1 : PRINT #3," "; : SCRUB 1
830       =1 : txt$=""
840       =REMAINDER : txt$=txt$(1 TO txtlen-1)
850     END SELect 
860     ELSE 
870       txt$=txt$ & key$
880   END IF 
890   IF key$=enter$ : RETurn txt$ & key$
900 END REPeat poll
910 END DEFine 
920 :
930 DEFine PROCedure CANCEL_ERROR
940 REMark This clears the BASIC system variable
950 REMark ERLIN once an error has been reported.
960 :
970 REMark The next line needs TURBO TOOLKIT, and
980 REMark assumes BASIC sysvars occupy 256 bytes.
990 REMark POKE_L BASIC_POINTER(0)-256+194,0
1010 REMark A better DIY Toolkit alternative is:
1020 FOR p=194 TO 197 : BPOKE p,0
1030 END DEFine 
1040 :
1050 DEFine PROCedure HELP
1060 CLS #3 : INK #3,4
1070 PRINT #3,"NETPAL types comands on a remote QL as"
1080 PRINT #3,"if you typed them there yourself."
1090 PRINT #3,"It uses the QL network file server."
1100 PRINT #3,\"NETPAL supports all QL commands - but"
1110 PRINT #3,"it is itself written in SuperBASIC, so"
1120 PRINT #3,"NEW, LRUN, LOAD CLEAR etc. disturb it!"
1130 PRINT #3, "CTRL  is the only edit key recognised,"
1140 PRINT #3;"and you CAN'T use it to move UP a line."
1150 PRINT #3;"Don't type fast or you'll beat the net!"
1160 PRINT #3,\"PROMPT$ is the prompt, and can include"
1170 PRINT #3,"the date - for instance, try entering"
1180 INK #3,7
1190 PRINT #3,"prompt$ = 'It is now date :'";
1200 INK #3,4 :PRINT #3;" or "; : INK #3,7
1210 PRINT #3,"= ''" : INK #3,4
1220 PRINT #3,\"Channel #3 is the remote display. Try:"
1230 INK #3,7
1240 PRINT #3,"DIR #3"; : INK #3,4 : PRINT #3," or ";
1250 INK #3,7 : PRINT #3,"RECOL #3,7,6,5,4,3,2,1,0"
1260 INK #3,4 : PRINT #3,"The command "; : INK #3,7
1270 PRINT #3,"PIX "; : INK #3,4
1280 PRINT #3;"reads the other screen."
1290 INK #3,7 : PRINT #3
1300 END DEFine 
1310 :
1320 DEFine PROCedure PIX
1330 REMark Copies a screen over the network.
1340 REMark This needs a MEM device on the other QL.
1350 REMark Add %s after ROW & COL with Minerva
1360 LOCal p,row,col,temp$
1370 INK #3,4
1380 PRINT #3;\\\\\"Loading other display... check MODE!"
1390 PRINT #3;\"Wait to see the whole display, then"
1400 PRINT #3;"press ENTER to re-start command entry."
1410 OPEN #3,"n1_mem"
1420 LET p=131072 : REMark Assumed base of 32K screen
1430 PUT #3\p
1440 FOR row=0 TO 255
1450   REMark TURBO TK PEEK$ could eliminate this loop:
1460   FOR col=row*128 TO row*128+127 STEP 2
1470     PUT #3,PEEK_W(p+col) : REMark Very slow for 32K!
1480   END FOR col
1490 END FOR row
1500 STARTUP
1510 INPUT #3,temp$
1520 HEADING
1530 END DEFine 
1540 :
1550 DEFine PROCedure STARTUP
1560 OPEN #3,n1_con_480x200a32x4
1570 END DEFine 
1580 :
1590 DEFine PROCedure HEADING
1600 CLS #3 : CSIZE #3,2,1
1610 PRINT #3,"QL NETPAL v 1.1" : CSIZE #3,0,0
1620 PRINT #3;"Enter HELP for HELP." : INK #3,7
1630 END DEFine 
1640 :
1650 DEFine PROCedure SCRUB(count)
1660 REMark Move cursor left on channel #3
1670 FOR i=1 TO count : CLS #3,115
1680 REMark Use temp=IO_TRAP(#3,19) on late Argos's
1690 END DEFine 
