1 REMark ### INSERT USER DEFINED CHARACTERS (32-191) AND CLIP TEXT FROM QUILL ###
2 REMark Composite version: 1991 October 16, written by David Moseley
3 REMark Uses ALCHP, ALTKEY, CHBASE, CLIP$, CURDIS, CURSEN, NEWCHAN & SYSBASE
4 :
5 REMark   Use  "CHARS"  to insert user defined characters
6 REMark   Use  "QLIP no_of_lines"  to clip text from Quill
7 :
8 MODE 4: WINDOW 512,202,0,0: INK 0: PAPER 4: CSIZE 2,1: CLS
9 AT  1,12:PRINT'Quill Qlipper': CSIZE 1,0:INK 0
10 AT  6,10:PRINT'Load TurboQuill+ Character Set (Y/n)?'
11 CSIZE 0,0: INK 2
12 AT 10,12:PRINT'These routines can be accessed directly by:'
13 AT 12,20:PRINT'"CHARS" - to insert user defined characters'
14 AT 13,20:PRINT'"QLIP no_of_lines" - to clip text from Quill':INK 7
15 AT 15,12:PRINT'NOTE that the following extensions are required:'
16 AT 17,24:PRINT'TK2 - ALCHP, ALTKEY, CURDIS & CURSEN'
17 AT 18,24:PRINT'DIY - CHBASE, CLIP$ NEWCHAN & SYSBASE'
18 REPeat lp
19  key=CODE(INKEY$(-1))
20  SELect ON key
21   = 78,110:STOP
22   = REMAINDER :CHARS
23  END SELect
24 END REPeat lp
25 :
26 DEFine PROCedure CHARS
27   MODE 4: WINDOW 513,202,0,0: INK 7: PAPER 2: CLS: CLS#0
28   WINDOW#2,513,202,0,0: INK#2,0: PAPER#2,4: OVER#2,0
29   SEL_WINDOW : ADDR_LOCS : NEW_CHRS : PAPER 2: STOP
30 END DEFine CHARS
31 :
32 DEFine PROCedure SEL_WINDOW
33   CSIZE 2,1: AT 3,4: INPUT'Modify the characters in window #';CH$
34   IF CH$='':CH$=NEWCHAN:END IF :CH=CH$:AT 3,37:PRINT CH
35   AT 6,6: INPUT'Characters are on drive?'!Dr$ : IF Dr$='':Dr$='Ram2_'
36   AT 6,31: PRINT Dr$: Dr$=Dr$&'CHARS_':CSIZE 0,0
37   CLS#2: AT#2,1,23:CSIZE#2,2,1: PRINT#2,"LOAD CHARACTER SET"
38   CSIZE#2,0,0: DIR#2,Dr$:POKE (SYSBASE+136),-1: REMark SV_CAPS = 163976
39   CSIZE#2,1,0:INPUT#2\\TO 11;'Name of Characters File : '&Dr$;file$
40   IF file$='': file$='THOR16_FOUNT': AT#2,PEEK_W(CHBASE(2)+36)/10,48:PRINT#2;file$
41   file$=Dr$&file$: file1$=file$: file2$=file$&'2'
42   CSIZE#2,0,0: OPEN#CH,Scr_480x202a16x0
43 END DEFine SEL_WINDOW
44 :
45 DEFine PROCedure ADDR_LOCS
46   fount1_addr = CHBASE(CH)+42 :REMark 1st fount address (96 characters)
47   fount2_addr = CHBASE(CH)+46 :REMark 2nd fount address (64 characters)
48   user_start1 = ALCHP(876) : user_start2 = ALCHP(588)
49   POKE_L fount1_addr,user_start1 : POKE_L fount2_addr,user_start2
50   LBYTES file1$,user_start1 : LBYTES file2$,user_start2
51 END DEFine ADDR_LOCS
52 :
53 DEFine PROCedure NEW_CHRS
54   PRINT#2\\\TO 16;file$!'characters are asigned to WINDOW#';CH
55   AT#CH,16,31:INK#CH,2:PRINT#CH;' Character Set#';CH!\
56   INK#CH,7:FOR C = 32 TO 191:PRINT#CH;CHR$(C);
57   AT#2,19,20:PRINT#2;'Use "QLIP no_of_lines" to get text from Quill'
58 END DEFine NEW_CHRS
59 :
60 DEFine PROCedure QLIP(last_line)
61  WINDOW#CH,480,210,16,16: IF last_line > 21: last_line=21 :END IF
62  cols=80: REMark Reduce for 64 or 40 column mode
63  IF cols=64:WINDOW#CH,448,200,34,16 :END IF
64  IF cols=40:CSIZE#CH,2,0: END IF
65 :
66  REMark     *** Clipping Conditions ***
67 :
68  UNDER#CH,1 : REMark Accept underlined text
69  col_start = 6 : IF col_start<1: col_start=1 :END IF
70  last_col = 76 : IF last_col>cols:last_col=cols :END IF
71  line_start = 1: IF line_start<1: line_start=1 :END IF
72  no_lines = last_line-line_start+1
73 :
74  REMark Echo window
75  CH2=NEWCHAN:OPEN#CH2,Scr_500x20a0x236:PAPER#CH2,2,0:INK#CH2,7:CLS#CH2
76  PRINT#CH2;'CLIPBOARD'\'Scanning'!no_lines!'lines':text$='':CURSEN#CH
77 :
78  REMark Clip text
79  FOR y = line_start+(cols=40)-1 TO last_line+(cols=80)-2
80    LineLen=0 : Line$='' : c$=' '
81    FOR x = col_start-1 TO last_col-1
82      AT#CH,y,x: old$=c$ :c$=CLIP$(#CH)
83      IF c$<>old$ OR c$<>' '
84        Line$=Line$&c$ : LineLen=LineLen+(c$<>"")
85      END IF
86    END FOR x
87    IF LineLen=0
88      text$=text$&CHR$(10)  :REMark Assume ENTER
89    ELSE
90      text$=text$&Line$     :REMark Assume continous
91      IF Line$(LineLen)<>' ':text$=text$&' ':END IF
92    END IF
93    PRINT#CH2,LineLen!Line$
94  END FOR y
95  ALTKEY'q',text$&CHR$(10):POKE SYSBASE+136,0
96  PRINT#CH2;text$\no_lines!"lines scanned: Result is in TEXT$ and on ALTKEY'q'."
97  CURDIS#CH:UNDER#CH,0: CLOSE#CH2: STOP
98 END DEFine QLIP
